﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using SuperMap.Desktop;
using SuperMap.Mapping;
using SuperMap.Data;

namespace SuperMap.Desktop.LocationTo
{
    public partial class _frmLocationTo : Form
    {

        public _frmLocationTo()
        {
            InitializeComponent();
            
        }
        TrackingLayer m_trackinglayer;
        GeoPoint m_geopoint = new GeoPoint();
        IFormMap m_activefrm;

        //Timer

        int m_TimeCount; 
        bool m_Time = true;

        private void btnLocationTo_Click(object sender, EventArgs e)
        {
            try
            {
                //Get the current active map window

                m_activefrm = Application.ActiveApplication.MainForm.FormManager.ActiveForm as IFormMap;

                //Get the tracking layer, add the point specified with X and Y coordinates to the layer, and locate the point

                m_trackinglayer = m_activefrm.MapControl.Map.TrackingLayer;
                GeoStyle geostyle = new GeoStyle();

                Double dX, dY;
                dX = Convert.ToDouble(txtX.Text);
                dY = Convert.ToDouble(txtY.Text);
                m_geopoint.X = dX;
                m_geopoint.Y = dY;

                //Set locating point style
                geostyle.LineColor=Color.Yellow;
                geostyle.MarkerSize =new Size2D(10,10);
                m_geopoint.Style = geostyle;

                //Set the map center and display scale

                Point2D centerpoint = new Point2D();
                centerpoint.X =dX;
                centerpoint.Y=dY;

                //Set the locating point to the center point of the map

                m_activefrm.MapControl.Map.Center = centerpoint;

                //Zoom out to a smaller scale

                m_activefrm.MapControl.Map.Scale = m_activefrm.MapControl.Map.Scale*5;

                //If locating point exists, enable timer and the locating point twinkles
                if (m_geopoint!=null )
                {
                    IFormMap formmap = SuperMap.Desktop.Application.ActiveForm as IFormMap;
                    Map map = formmap.MapControl.Map;
                    SuperMap.Desktop.Application.ActiveApplication.Output.Output("当前位置：" + "(" + map.Center.X + "," + map.Center.Y + ")");

                    timer1.Enabled = true;
                    timer1.Interval = 500;
                    m_TimeCount = 1;
                    timer1.Start();
                }
                else
                {
                    SuperMap.Desktop.Application.ActiveApplication.Output.Output("Locating point error！");
                }
            }
            catch (System.Exception ex)
            {
                SuperMap.Desktop.Application.ActiveApplication.Output.Output(ex.StackTrace);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            m_trackinglayer.Clear();

            //Stop twinkling after 20 times

            if (m_TimeCount > 20)
            {
                timer1.Enabled = false;
                timer1.Stop();
                m_TimeCount = 0;
            }
            else
            {
                if (m_Time == true)
                {
                    //Add locating point to tracking layer

                    m_trackinglayer.Add((Geometry)m_geopoint, "Locating Point");
                    m_activefrm.MapControl.Map.Refresh();
                    m_TimeCount++;
                }
                else
                {
                    m_activefrm.MapControl.Map.Refresh();
                    m_activefrm.MapControl.Refresh();
                }
            }
            if (m_Time == true)
            {
                m_Time = false;
            }
            else
            {
                m_Time = true;
            }
        }
    }
}
